Dynamic data update in Angular Accumulation Chart component

25 Sep 202412 minutes to read

Adding a new data point

The addPoint method is used to dynamically add a new data point to the accumulation chart series. This method is particularly useful when you want to update the chart with a new data point without having to refresh the entire accumulation chart. This method takes two parameters:

  • The first parameter is the new data point to add to your existing data source.
  • The optional second parameter specifies the animation duration for adding the new data point.
var piechart = new ej.charts.AccumulationChart({
        series: [
          {
            dataSource: [
              { x: 'Jan', y: 3 },
              { x: 'Feb', y: 3.5 },
              { x: 'Mar', y: 7 },
              { x: 'Apr', y: 13.5 },
              { x: 'May', y: 19 },
              { x: 'Jun', y: 23.5 },
              { x: 'Jul', y: 26 },
              { x: 'Aug', y: 25 },
              { x: 'Sep', y: 21 },
              { x: 'Oct', y: 15 },
            ],
            type: 'Pie',
            xName: 'x',
            yName: 'y',
          },
        ],
}, '#element');

document.getElementById('add').onclick = function () {
    piechart.series[0].addPoint({ x: 'Nov', y: 12 });
  }
<!DOCTYPE html><html lang="en"><head>
    <title>EJ2 Animation</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    
    
<script src="https://cdn.syncfusion.com/ej2/29.2.4/dist/ej2.min.js" type="text/javascript"></script>
<script src="https://cdn.syncfusion.com/ej2/syncfusion-helper.js" type ="text/javascript"></script>
</head>

<body>
    
    <div id="container">
        <div id="element"></div>
        <button id='add'>Add Point</button>
    </div>


<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

Removing an existing data point

The removePoint method is used to dynamically remove a data point from the accumulation chart series. This method is particularly useful when you want to update the accumulation chart by removing an existing data point without having to refresh the entire accumulation chart. This method takes two parameters:

  • The first parameter is the index of the data point that needs to be removed from the existing data source.
  • The optional second parameter specifies the animation duration for removing the data point.
var piechart = new ej.charts.AccumulationChart({
        series: [
          {
            dataSource: [
              { x: 'Jan', y: 3 },
              { x: 'Feb', y: 3.5 },
              { x: 'Mar', y: 7 },
              { x: 'Apr', y: 13.5 },
              { x: 'May', y: 19 },
              { x: 'Jun', y: 23.5 },
              { x: 'Jul', y: 26 },
              { x: 'Aug', y: 25 },
              { x: 'Sep', y: 21 },
              { x: 'Oct', y: 15 },
            ],
            type: 'Pie',
            xName: 'x',
            yName: 'y',
          },
        ],
}, '#element');

document.getElementById('add').onclick = function () {
    piechart.series[0].removePoint(0);
  }
<!DOCTYPE html><html lang="en"><head>
    <title>EJ2 Animation</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    
    
<script src="https://cdn.syncfusion.com/ej2/29.2.4/dist/ej2.min.js" type="text/javascript"></script>
<script src="https://cdn.syncfusion.com/ej2/syncfusion-helper.js" type ="text/javascript"></script>
</head>

<body>
    
    <div id="container">
        <div id="element"></div>
        <button id='add'>Remove Point</button>
    </div>


<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

Replacing entire data points

To replace the existing data source in the accumulation chart with a new data source, you can simply use the setData method. This method allows you to replace the existing data points in the accumulation chart series with a new set of data points, enabling you to easily update the accumulation chart with new information. This method takes two parameters:

  • The first parameter is the new set of data points to be updated.
  • The optional second parameter specifies the animation duration for updating the new data source.
var piechart = new ej.charts.AccumulationChart({
  series: [
    {
      dataSource: [
        { x: 'Jan', y: 3 },
        { x: 'Feb', y: 3.5 },
        { x: 'Mar', y: 7 },
        { x: 'Apr', y: 13.5 },
        { x: 'May', y: 19 },
        { x: 'Jun', y: 23.5 },
        { x: 'Jul', y: 26 },
        { x: 'Aug', y: 25 },
        { x: 'Sep', y: 21 },
        { x: 'Oct', y: 15 },
      ],
      type: 'Pie',
      xName: 'x',
      yName: 'y',
    },
  ],
}, '#element');

document.getElementById('add').onclick = function () {
  const newData = [
    { x: 'Jan', y: 3 },
    { x: 'Feb', y: 3.5 },
    { x: 'Mar', y: 7 },
    { x: 'Aug', y: 25 },
    { x: 'Sep', y: 21 },
    { x: 'Oct', y: 15 },
  ];
  piechart.series[0].setData(newData, 500);
}
<!DOCTYPE html><html lang="en"><head>
    <title>EJ2 Animation</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    
    
<script src="https://cdn.syncfusion.com/ej2/29.2.4/dist/ej2.min.js" type="text/javascript"></script>
<script src="https://cdn.syncfusion.com/ej2/syncfusion-helper.js" type ="text/javascript"></script>
</head>

<body>
    
    <div id="container">
        <div id="element"></div>
        <button id='add'>Update Series</button>
    </div>


<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

Dynamic data update in Vue Accumulation Chart component

25 Sep 202418 minutes to read

Adding a new data point

The addPoint method is used to dynamically add a new data point to the accumulation chart series. This method is particularly useful when you want to update the chart with a new data point without having to refresh the entire accumulation chart. This method takes two parameters:

  • The first parameter is the new data point to add to your existing data source.
  • The optional second parameter specifies the animation duration for adding the new data point.
<template>
  <div id="app">
    <ejs-accumulationchart ref="chart" id="container" :legendSettings='legendSettings'>
      <e-accumulation-series-collection>
        <e-accumulation-series :dataSource='seriesData' xName='x' yName='y' legendShape='Rectangle'>
        </e-accumulation-series>
      </e-accumulation-series-collection>
    </ejs-accumulationchart>
    <ejs-button id='add' @click.native='onClick'>Add Point</ejs-button>
  </div>
</template>
<script setup>
import { provide } from "vue";
import { AccumulationChartComponent as EjsAccumulationchart, AccumulationSeriesCollectionDirective as EAccumulationSeriesCollection, AccumulationSeriesDirective as EAccumulationSeries, PieSeries, AccumulationDataLabel, AccumulationLegend } from "@syncfusion/ej2-vue-charts";
import { ButtonComponent as EjsButton } from "@syncfusion/ej2-vue-buttons";

const seriesData = [
{ x: 'Jan', y: 3 }, { x: 'Feb', y: 3.5 }, { x: 'Mar', y: 7 }, { x: 'Apr', y: 13.5 }, { x: 'May', y: 19 }, { x: 'Jun', y: 23.5 }, { x: 'Jul', y: 26 }, { x: 'Aug', y: 25 },
{ x: 'Sep', y: 21 }, { x: 'Oct', y: 15 }, { x: 'Nov', y: 15 }
];
const legendSettings = { visible: true};

provide('accumulationchart', [PieSeries, AccumulationDataLabel, AccumulationLegend]);

const onClick = function() {     
  this.$refs.chart.ej2Instances.series[0].addPoint({ x: 'Dec', y: 15 });
};
</script>
<style>
#container {
  height: 350px;
}
</style>
<template>
  <div id="app">
    <ejs-accumulationchart ref="chart" id="container" :legendSettings='legendSettings'>
      <e-accumulation-series-collection>
        <e-accumulation-series :dataSource='seriesData' xName='x' yName='y' legendShape='Rectangle'>
        </e-accumulation-series>
      </e-accumulation-series-collection>
    </ejs-accumulationchart>
    <ejs-button id='add' @click.native='onClick'>Add Point</ejs-button>
  </div>
</template>
<script>
import Vue from "vue";
import { AccumulationChartComponent, AccumulationSeriesCollectionDirective, AccumulationSeriesDirective, PieSeries, AccumulationDataLabel, AccumulationLegend } from "@syncfusion/ej2-vue-charts";
import { ButtonPlugin } from "@syncfusion/ej2-vue-buttons";
Vue.use(ButtonPlugin);

export default {
  name: "App",
  components: {
    "ejs-accumulationchart": AccumulationChartComponent,
    "e-accumulation-series-collection": AccumulationSeriesCollectionDirective,
    "e-accumulation-series": AccumulationSeriesDirective
  },
  data() {
    return {
      seriesData: [
      { x: 'Jan', y: 3 }, { x: 'Feb', y: 3.5 }, { x: 'Mar', y: 7 }, { x: 'Apr', y: 13.5 }, { x: 'May', y: 19 }, { x: 'Jun', y: 23.5 }, { x: 'Jul', y: 26 }, { x: 'Aug', y: 25 },
      { x: 'Sep', y: 21 }, { x: 'Oct', y: 15 }, { x: 'Nov', y: 15 }
      ],
      legendSettings: {
        visible: true
      },
    };
  },
  provide: {
    accumulationchart: [PieSeries, AccumulationDataLabel, AccumulationLegend]
  },
  methods: {
      onClick: function() {     
        this.$refs.chart.ej2Instances.series[0].addPoint({ x: 'Japan', y: 118.2 });
      }
  }
};
</script>
<style>
#container {
  height: 350px;
}
</style>

Removing an existing data point

The removePoint method is used to dynamically remove a data point from the accumulation chart series. This method is particularly useful when you want to update the accumulation chart by removing an existing data point without having to refresh the entire accumulation chart. This method takes two parameters:

  • The first parameter is the index of the data point that needs to be removed from the existing data source.
  • The optional second parameter specifies the animation duration for removing the data point.
<template>
  <div id="app">
    <ejs-accumulationchart ref="chart" id="container" :legendSettings='legendSettings'>
      <e-accumulation-series-collection>
        <e-accumulation-series :dataSource='seriesData' xName='x' yName='y' legendShape='Rectangle'>
        </e-accumulation-series>
      </e-accumulation-series-collection>
    </ejs-accumulationchart>
    <ejs-button id='add' @click.native='onClick'>Add Point</ejs-button>
  </div>
</template>
<script setup>
import { provide } from "vue";
import { AccumulationChartComponent as EjsAccumulationchart, AccumulationSeriesCollectionDirective as EAccumulationSeriesCollection, AccumulationSeriesDirective as EAccumulationSeries, PieSeries, AccumulationDataLabel, AccumulationLegend } from "@syncfusion/ej2-vue-charts";
import { ButtonComponent as EjsButton } from "@syncfusion/ej2-vue-buttons";

const seriesData = [
{ x: 'Jan', y: 3 }, { x: 'Feb', y: 3.5 }, { x: 'Mar', y: 7 }, { x: 'Apr', y: 13.5 }, { x: 'May', y: 19 }, { x: 'Jun', y: 23.5 }, { x: 'Jul', y: 26 }, { x: 'Aug', y: 25 },
{ x: 'Sep', y: 21 }, { x: 'Oct', y: 15 }, { x: 'Nov', y: 15 }
];
const legendSettings = { visible: true};

provide('accumulationchart', [PieSeries, AccumulationDataLabel, AccumulationLegend]);

const onClick = function() {     
  this.$refs.chart.ej2Instances.series[0].removePoint(0);
};
</script>
<style>
#container {
  height: 350px;
}
</style>
<template>
  <div id="app">
    <ejs-accumulationchart ref="chart" id="container" :legendSettings='legendSettings'>
      <e-accumulation-series-collection>
        <e-accumulation-series :dataSource='seriesData' xName='x' yName='y' legendShape='Rectangle'>
        </e-accumulation-series>
      </e-accumulation-series-collection>
    </ejs-accumulationchart>
    <ejs-button id='add' @click.native='onClick'>Add Point</ejs-button>
  </div>
</template>
<script>
import Vue from "vue";
import { AccumulationChartComponent, AccumulationSeriesCollectionDirective, AccumulationSeriesDirective, PieSeries, AccumulationDataLabel, AccumulationLegend } from "@syncfusion/ej2-vue-charts";
import { ButtonPlugin } from "@syncfusion/ej2-vue-buttons";
Vue.use(ButtonPlugin);

export default {
  name: "App",
  components: {
    "ejs-accumulationchart": AccumulationChartComponent,
    "e-accumulation-series-collection": AccumulationSeriesCollectionDirective,
    "e-accumulation-series": AccumulationSeriesDirective
  },
  data() {
    return {
      seriesData: [
      { x: 'Jan', y: 3 }, { x: 'Feb', y: 3.5 }, { x: 'Mar', y: 7 }, { x: 'Apr', y: 13.5 }, { x: 'May', y: 19 }, { x: 'Jun', y: 23.5 }, { x: 'Jul', y: 26 }, { x: 'Aug', y: 25 },
      { x: 'Sep', y: 21 }, { x: 'Oct', y: 15 }, { x: 'Nov', y: 15 }
      ],
      legendSettings: {
        visible: true
      },
    };
  },
  provide: {
    accumulationchart: [PieSeries, AccumulationDataLabel, AccumulationLegend]
  },
  methods: {
      onClick: function() {     
        this.$refs.chart.ej2Instances.series[0].removePoint(0);
      }
  }
};
</script>
<style>
#container {
  height: 350px;
}
</style>

Replacing entire data points

To replace the existing data source in the accumulation chart with a new data source, you can simply use the setData method. This method allows you to replace the existing data points in the accumulation chart series with a new set of data points, enabling you to easily update the accumulation chart with new information. This method takes two parameters:

  • The first parameter is the new set of data points to be updated.
  • The optional second parameter specifies the animation duration for updating the new data source.
<template>
  <div id="app">
    <ejs-accumulationchart ref="chart" id="container" :legendSettings='legendSettings'>
      <e-accumulation-series-collection>
        <e-accumulation-series :dataSource='seriesData' xName='x' yName='y' legendShape='Rectangle'>
        </e-accumulation-series>
      </e-accumulation-series-collection>
    </ejs-accumulationchart>
    <ejs-button id='add' @click.native='onClick'>Add Point</ejs-button>
  </div>
</template>
<script setup>
import { provide } from "vue";
import { AccumulationChartComponent as EjsAccumulationchart, AccumulationSeriesCollectionDirective as EAccumulationSeriesCollection, AccumulationSeriesDirective as EAccumulationSeries, PieSeries, AccumulationDataLabel, AccumulationLegend } from "@syncfusion/ej2-vue-charts";
import { ButtonComponent as EjsButton } from "@syncfusion/ej2-vue-buttons";

const seriesData = [
{ x: 'Jan', y: 3 }, { x: 'Feb', y: 3.5 }, { x: 'Mar', y: 7 }, { x: 'Apr', y: 13.5 }, { x: 'May', y: 19 }, { x: 'Jun', y: 23.5 }, { x: 'Jul', y: 26 }, { x: 'Aug', y: 25 },
{ x: 'Sep', y: 21 }, { x: 'Oct', y: 15 }, { x: 'Nov', y: 15 }
];
const legendSettings = { visible: true};

provide('accumulationchart', [PieSeries, AccumulationDataLabel, AccumulationLegend]);

const onClick = function() {     
  this.$refs.chart.ej2Instances.series[0].setData(newData, 500);
};
</script>
<style>
#container {
  height: 350px;
}
</style>
<template>
  <div id="app">
    <ejs-accumulationchart ref="chart" id="container" :legendSettings='legendSettings'>
      <e-accumulation-series-collection>
        <e-accumulation-series :dataSource='seriesData' xName='x' yName='y' legendShape='Rectangle'>
        </e-accumulation-series>
      </e-accumulation-series-collection>
    </ejs-accumulationchart>
    <ejs-button id='add' @click.native='onClick'>Add Point</ejs-button>
  </div>
</template>
<script>
import Vue from "vue";
import { AccumulationChartComponent, AccumulationSeriesCollectionDirective, AccumulationSeriesDirective, PieSeries, AccumulationDataLabel, AccumulationLegend } from "@syncfusion/ej2-vue-charts";
import { ButtonPlugin } from "@syncfusion/ej2-vue-buttons";
Vue.use(ButtonPlugin);

export default {
  name: "App",
  components: {
    "ejs-accumulationchart": AccumulationChartComponent,
    "e-accumulation-series-collection": AccumulationSeriesCollectionDirective,
    "e-accumulation-series": AccumulationSeriesDirective
  },
  data() {
    return {
      seriesData: [
      { x: 'Jan', y: 3 }, { x: 'Feb', y: 3.5 }, { x: 'Mar', y: 7 }, { x: 'Apr', y: 13.5 }, { x: 'May', y: 19 }, { x: 'Jun', y: 23.5 }, { x: 'Jul', y: 26 }, { x: 'Aug', y: 25 },
      { x: 'Sep', y: 21 }, { x: 'Oct', y: 15 }, { x: 'Nov', y: 15 }
      ],
      legendSettings: {
        visible: true
      },
    };
  },
  provide: {
    accumulationchart: [PieSeries, AccumulationDataLabel, AccumulationLegend]
  },
  methods: {
    onClick: function () {
      const newData = [
        { x: 'Jan', y: 3 },
        { x: 'Feb', y: 3.5 },
        { x: 'Mar', y: 7 },
        { x: 'Aug', y: 25 },
        { x: 'Sep', y: 21 },
        { x: 'Oct', y: 15 },
      ];
      this.$refs.chart.ej2Instances.series[0].setData(newData, 500);
    }
  }
};
</script>
<style>
#container {
  height: 350px;
}
</style>

Dynamic data update in Angular Accumulation Chart component

25 Sep 20249 minutes to read

Adding a new data point

The addPoint method is used to dynamically add a new data point to the accumulation chart series. This method is particularly useful when you want to update the chart with a new data point without having to refresh the entire accumulation chart. This method takes two parameters:

  • The first parameter is the new data point to add to your existing data source.
  • The optional second parameter specifies the animation duration for adding the new data point.
import { NgModule, ViewChild } from '@angular/core'
import { BrowserModule } from '@angular/platform-browser'
import { AccumulationChartModule } from '@syncfusion/ej2-angular-charts'
import { PieSeriesService, AccumulationLegendService, AccumulationTooltipService, AccumulationAnnotationService,
  AccumulationDataLabelService, AccumulationChartComponent } from '@syncfusion/ej2-angular-charts'



import { Component, OnInit } from '@angular/core';
import { pieData } from './datasource';
@Component({
imports: [
         AccumulationChartModule
    ],

providers: [PieSeriesService, AccumulationLegendService, AccumulationTooltipService, AccumulationDataLabelService,
     AccumulationAnnotationService, AccumulationChartComponent],
standalone: true,
    selector: 'app-container',
    template: `<ejs-accumulationchart #chart id="chart-container" [legendSettings]='legendSettings'>
        <e-accumulation-series-collection>
            <e-accumulation-series [dataSource]='piedata' xName='x' yName='y'  legendShape='Rectangle'></e-accumulation-series>
        </e-accumulation-series-collection>
    </ejs-accumulationchart>
    <button ej-button id='add' (click)='click()'>Add Point</button>`
})
export class AppComponent implements OnInit {
    @ViewChild('chart')
    public chart?: AccumulationChartComponent;
    public piedata?: Object[];
    public legendSettings?: Object;
    ngOnInit(): void {
        this.legendSettings = {
          visible: true
        };
        this.piedata = pieData;
    }
    click() {
        (this.chart as any).series[0].addPoint({ x: 'Dec', y: 15 });
      }
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Removing an existing data point

The removePoint method is used to dynamically remove a data point from the accumulation chart series. This method is particularly useful when you want to update the accumulation chart by removing an existing data point without having to refresh the entire accumulation chart. This method takes two parameters:

  • The first parameter is the index of the data point that needs to be removed from the existing data source.
  • The optional second parameter specifies the animation duration for removing the data point.
import { NgModule, ViewChild } from '@angular/core'
import { BrowserModule } from '@angular/platform-browser'
import { AccumulationChartModule } from '@syncfusion/ej2-angular-charts'
import { PieSeriesService, AccumulationLegendService, AccumulationTooltipService, AccumulationAnnotationService,
  AccumulationDataLabelService, AccumulationChartComponent } from '@syncfusion/ej2-angular-charts'



import { Component, OnInit } from '@angular/core';
import { pieData } from './datasource';
@Component({
imports: [
         AccumulationChartModule
    ],

providers: [PieSeriesService, AccumulationLegendService, AccumulationTooltipService, AccumulationDataLabelService,
     AccumulationAnnotationService, AccumulationChartComponent],
standalone: true,
    selector: 'app-container',
    template: `<ejs-accumulationchart #chart id="chart-container" [legendSettings]='legendSettings'>
        <e-accumulation-series-collection>
            <e-accumulation-series [dataSource]='piedata' xName='x' yName='y'  legendShape='Rectangle'></e-accumulation-series>
        </e-accumulation-series-collection>
    </ejs-accumulationchart>
    <button ej-button id='add' (click)='click()'>Remove Point</button>`
})
export class AppComponent implements OnInit {
    @ViewChild('chart')
    public chart?: AccumulationChartComponent;
    public piedata?: Object[];
    public legendSettings?: Object;
    ngOnInit(): void {
        this.legendSettings = {
          visible: true
        };
        this.piedata = pieData;
    }
    click() {
        (this.chart as any).series[0].removePoint(0);
      }
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Replacing entire data points

To replace the existing data source in the accumulation chart with a new data source, you can simply use the setData method. This method allows you to replace the existing data points in the accumulation chart series with a new set of data points, enabling you to easily update the accumulation chart with new information. This method takes two parameters:

  • The first parameter is the new set of data points to be updated.
  • The optional second parameter specifies the animation duration for updating the new data source.
import { NgModule, ViewChild } from '@angular/core'
import { BrowserModule } from '@angular/platform-browser'
import { AccumulationChartModule } from '@syncfusion/ej2-angular-charts'
import { PieSeriesService, AccumulationLegendService, AccumulationTooltipService, AccumulationAnnotationService,
  AccumulationDataLabelService, AccumulationChartComponent } from '@syncfusion/ej2-angular-charts'



import { Component, OnInit } from '@angular/core';
import { pieData } from './datasource';
@Component({
imports: [
         AccumulationChartModule
    ],

providers: [PieSeriesService, AccumulationLegendService, AccumulationTooltipService, AccumulationDataLabelService,
     AccumulationAnnotationService, AccumulationChartComponent],
standalone: true,
    selector: 'app-container',
    template: `<ejs-accumulationchart #chart id="chart-container" [legendSettings]='legendSettings'>
        <e-accumulation-series-collection>
            <e-accumulation-series [dataSource]='piedata' xName='x' yName='y'  legendShape='Rectangle'></e-accumulation-series>
        </e-accumulation-series-collection>
    </ejs-accumulationchart>
    <button ej-button id='add' (click)='click()'>Update Data</button>`
})
export class AppComponent implements OnInit {
    @ViewChild('chart')
    public chart?: AccumulationChartComponent;
    public piedata?: Object[];
    public legendSettings?: Object;
    public getRandomInt(min: number, max: number) {
        return Math.floor(Math.random() * (max - min + 1)) + min;
    }
    ngOnInit(): void {
        this.legendSettings = {
          visible: true
        };
        this.piedata = pieData;
    }
    click() {
        const newData = [
            { x: 'Jan', y: 3 },
            { x: 'Feb', y: 3.5 },
            { x: 'Mar', y: 7 },
            { x: 'Aug', y: 25 },
            { x: 'Sep', y: 21 },
            { x: 'Oct', y: 15 },
          ];
        (this.chart as any).series[0].setData(newData, 500);
      }
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Dynamic data update in React Accumulation Chart component

30 Sep 202413 minutes to read

Adding a new data point

The addPoint method is used to dynamically add a new data point to the accumulation chart series. This method is particularly useful when you want to update the chart with a new data point without having to refresh the entire accumulation chart. This method takes two parameters:

  • The first parameter is the new data point to add to your existing data source.
  • The optional second parameter specifies the animation duration for adding the new data point.
import * as React from "react";
import * as ReactDOM from "react-dom";
import { AccumulationChartComponent, AccumulationSeriesCollectionDirective, AccumulationSeriesDirective, Inject, AccumulationAnnotation, AccumulationAnnotationsDirective, AccumulationAnnotationDirective, AccumulationLegend, AccumulationSeries }
  from '@syncfusion/ej2-react-charts';
import { pieData } from '../datasource.ts';

function App() {

  const template = chartTemplate;
  const chartRef = React.useRef < AccumulationChartComponent > (null);
  let click = () => {
    if (chartRef.current) {
      (chartRef.current.series[0]).addPoint({ x: 'Dec', y: 15 });
    }
  }
  function chartTemplate() {
    return (<div className='template'>
      <div style={{ border: '1px solid black', backgroundColor: '#f5f5f5', padding: '5px 5px 5px 5px' }}>13.5</div>
    </div>);
  };

  return <div><AccumulationChartComponent id='charts' ref={chartRef} legendSettings={{ visible: false }} >
    <Inject services={[AccumulationAnnotation, AccumulationLegend]} />
    <AccumulationSeriesCollectionDirective>
      <AccumulationSeriesDirective dataSource={pieData} xName='x' yName='y' legendShape='Rectangle'>
      </AccumulationSeriesDirective>
    </AccumulationSeriesCollectionDirective>
  </AccumulationChartComponent>
    <button id='add' onClick={click}>click</button>
  </div>

};
export default App;
ReactDOM.render(<App />, document.getElementById("charts"));
import * as React from "react";
import * as ReactDOM from "react-dom";
import { AccumulationChartComponent, AccumulationSeriesCollectionDirective, AccumulationSeriesDirective, Inject, AccumulationAnnotation, AccumulationAnnotationsDirective, AccumulationAnnotationDirective, AccumulationLegend, AccumulationSeries }
  from '@syncfusion/ej2-react-charts';
import { pieData } from '../datasource.ts';

function App() {

  const chartRef = React.useRef<AccumulationChartComponent>(null);
  let click = () => {
    if (chartRef.current) {
      (chartRef.current.series[0] as AccumulationSeries).addPoint({ x: 'Dec', y: 15 });
    }
  }

  return <div><AccumulationChartComponent id='charts' ref={chartRef} legendSettings={{ visible: false }} >
    <Inject services={[AccumulationAnnotation, AccumulationLegend]} />
    <AccumulationSeriesCollectionDirective>
      <AccumulationSeriesDirective dataSource={pieData} xName='x' yName='y' legendShape='Rectangle'>
      </AccumulationSeriesDirective>
    </AccumulationSeriesCollectionDirective>
  </AccumulationChartComponent>
    <button id='add' onClick={click}>click</button>
  </div>

};
export default App;
ReactDOM.render(<App />, document.getElementById("charts"));

Removing an existing data point

The removePoint method is used to dynamically remove a data point from the accumulation chart series. This method is particularly useful when you want to update the accumulation chart by removing an existing data point without having to refresh the entire accumulation chart. This method takes two parameters:

  • The first parameter is the index of the data point that needs to be removed from the existing data source.
  • The optional second parameter specifies the animation duration for removing the data point.
import * as React from "react";
import * as ReactDOM from "react-dom";
import { AccumulationChartComponent, AccumulationSeriesCollectionDirective, AccumulationSeriesDirective, Inject, AccumulationAnnotation, AccumulationAnnotationsDirective, AccumulationAnnotationDirective, AccumulationLegend, AccumulationSeries }
  from '@syncfusion/ej2-react-charts';
import { pieData } from '../datasource.ts';

function App() {

  const template = chartTemplate;
  const chartRef = React.useRef < AccumulationChartComponent > (null);
  let click = () => {
    if (chartRef.current) {
      (chartRef.current.series[0]).removePoint(0);
    }
  }
  function chartTemplate() {
    return (<div className='template'>
      <div style={{ border: '1px solid black', backgroundColor: '#f5f5f5', padding: '5px 5px 5px 5px' }}>13.5</div>
    </div>);
  };

  return <div><AccumulationChartComponent id='charts' ref={chartRef} legendSettings={{ visible: false }} >
    <Inject services={[AccumulationAnnotation, AccumulationLegend]} />
    <AccumulationSeriesCollectionDirective>
      <AccumulationSeriesDirective dataSource={pieData} xName='x' yName='y' legendShape='Rectangle'>
      </AccumulationSeriesDirective>
    </AccumulationSeriesCollectionDirective>
  </AccumulationChartComponent>
    <button id='add' onClick={click}>click</button>
  </div>

};
export default App;
ReactDOM.render(<App />, document.getElementById("charts"));
import * as React from "react";
import * as ReactDOM from "react-dom";
import { AccumulationChartComponent, AccumulationSeriesCollectionDirective, AccumulationSeriesDirective, Inject, AccumulationAnnotation, AccumulationAnnotationsDirective, AccumulationAnnotationDirective, AccumulationLegend, AccumulationSeries }
  from '@syncfusion/ej2-react-charts';
import { pieData } from '../datasource.ts';

function App() {

  const chartRef = React.useRef<AccumulationChartComponent>(null);
  let click = () => {
    if (chartRef.current) {
      (chartRef.current.series[0] as AccumulationSeries).removePoint(0);
    }
  }

  return <div><AccumulationChartComponent id='charts' ref={chartRef} legendSettings={{ visible: false }} >
    <Inject services={[AccumulationAnnotation, AccumulationLegend]} />
    <AccumulationSeriesCollectionDirective>
      <AccumulationSeriesDirective dataSource={pieData} xName='x' yName='y' legendShape='Rectangle'>
      </AccumulationSeriesDirective>
    </AccumulationSeriesCollectionDirective>
  </AccumulationChartComponent>
    <button id='add' onClick={click}>click</button>
  </div>

};
export default App;
ReactDOM.render(<App />, document.getElementById("charts"));

Replacing entire data points

To replace the existing data source in the accumulation chart with a new data source, you can simply use the setData method. This method allows you to replace the existing data points in the accumulation chart series with a new set of data points, enabling you to easily update the accumulation chart with new information. This method takes two parameters:

  • The first parameter is the new set of data points to be updated.
  • The optional second parameter specifies the animation duration for updating the new data source.
import * as React from "react";
import * as ReactDOM from "react-dom";
import { AccumulationChartComponent, AccumulationSeriesCollectionDirective, AccumulationSeriesDirective, Inject,AccumulationAnnotation, AccumulationAnnotationsDirective, AccumulationAnnotationDirective, AccumulationLegend, AccumulationSeries}
from'@syncfusion/ej2-react-charts';
import { pieData } from '../datasource.ts';

function App() {

  const chartRef = React.useRef<AccumulationChartComponent>(null);
  let click= ()=>{
    const newData = [
      { x: 'Jan', y: 3 },
      { x: 'Feb', y: 3.5 },
      { x: 'Mar', y: 7 },
      { x: 'Aug', y: 25 },
      { x: 'Sep', y: 21 },
      { x: 'Oct', y: 15 },
    ];

    if (chartRef.current) {
      (chartRef.current.series[0] ).setData(newData, 500);
    }
  }

  return <div><AccumulationChartComponent id='charts' ref={chartRef} legendSettings={{visible:false}} >
      <Inject services={[AccumulationAnnotation, AccumulationLegend]} />
      <AccumulationSeriesCollectionDirective>
        <AccumulationSeriesDirective dataSource={pieData} xName='x' yName='y' legendShape='Rectangle'>
        </AccumulationSeriesDirective>
      </AccumulationSeriesCollectionDirective>
    </AccumulationChartComponent>
    <button id='add' onClick={click}>click</button>
    </div>

};
export default App;
ReactDOM.render(<App />, document.getElementById("charts"));
import * as React from "react";
import * as ReactDOM from "react-dom";
import { AccumulationChartComponent, AccumulationSeriesCollectionDirective, AccumulationSeriesDirective, Inject,AccumulationAnnotation, AccumulationAnnotationsDirective, AccumulationAnnotationDirective, AccumulationLegend, AccumulationSeries}
from'@syncfusion/ej2-react-charts';
import { pieData } from '../datasource.ts';

function App() {

  const chartRef = React.useRef<AccumulationChartComponent>(null);
  let click= ()=>{
    const newData = [
      { x: 'Jan', y: 3 },
      { x: 'Feb', y: 3.5 },
      { x: 'Mar', y: 7 },
      { x: 'Aug', y: 25 },
      { x: 'Sep', y: 21 },
      { x: 'Oct', y: 15 },
    ];

    if (chartRef.current) {
      (chartRef.current.series[0] as AccumulationSeries).setData(newData, 500);
    }
  }

  return <div><AccumulationChartComponent id='charts' ref={chartRef} legendSettings={{visible:false}} >
      <Inject services={[AccumulationAnnotation, AccumulationLegend]} />
      <AccumulationSeriesCollectionDirective>
        <AccumulationSeriesDirective dataSource={pieData} xName='x' yName='y' legendShape='Rectangle'>
        </AccumulationSeriesDirective>
      </AccumulationSeriesCollectionDirective>
    </AccumulationChartComponent>
    <button id='add' onClick={click}>click</button>
    </div>

};
export default App;
ReactDOM.render(<App />, document.getElementById("charts"));